﻿package 
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	public class IMGDBros extends MovieClip 
	{
		public const EDGE_DISTANCE:Number = 200;
		private var cam:Point = new Point(0, 0);
		
		public function IMGDBros():void 
		{
			addEventListener(Event.ENTER_FRAME, Update);
		}
		 
		public function Update(e:Event) {
			var W:MovieClip = (this.World as MovieClip);
			var P1:Player = (W.Play1 as Player);
			
			// Create a smooth camera that will anticipate the player using the player's x velocity
			// (camera focus will be in front of the player, but will lag behind when player is falling)
			var velo:Point = new Point( P1.x + P1.velo.x * 20 - cam.x, P1.y - cam.y);
			cam.x += velo.x * .1;
			cam.y += velo.y * .1;
			
			// Keep camera focus onscreen without letting camera show outside the level area
			var focus:Point = W.localToGlobal( new Point( cam.x, cam.y));
			
			var bounds:Rectangle = new Rectangle(EDGE_DISTANCE, EDGE_DISTANCE,
				stage.stageWidth - 2 * EDGE_DISTANCE, stage.stageHeight - 2 * EDGE_DISTANCE);
				
			if ( focus.x > bounds.right) {
				W.x -= ( focus.x - bounds.right);
				if (W.x < - ( W.Level.width - stage.stageWidth))
					W.x = - (W.Level.width - stage.stageWidth);
			}
			if (focus.x < bounds.left) {
				W.x += bounds.left - focus.x;
				if (W.x > 0)
					W.x = 0;
			}
			if (focus.y < bounds.top) {
				W.y -= focus.y - bounds.top;
				if (W.y > 0) 
					W.y = 0;
			}
			if (focus.y > bounds.bottom) {
				W.y -= focus.y - bounds.bottom;
				if (W.y < - (W.Level.height - stage.stageHeight))
					W.y = - (W.Level.height - stage.stageHeight);
			}		
		}
	}
	
}